module.exports = function (api) {

  api.cache(true);

  const presets = [
    [
      "@babel/preset-env",
      {
        "targets": {
          "node": 4
        }
      }
    ],
    "@babel/preset-flow"
  ];
  const plugins = [
    [
      "@babel/plugin-transform-flow-strip-types"
    ],
    ["@babel/plugin-transform-modules-commonjs", {
      "lazy": process.env.NODE_ENV === 'test' ? false : ["*"]
    }],
    [
      "babel-plugin-transform-builtin-extend",
      {
        "globals": [
          "Error",
          "Array",
          "Map"
        ]
      }
    ],
    [
      "@babel/plugin-transform-runtime",
      {
        "helpers": false,
        "regenerator": true
      }
    ],
    [
      "syntax-async-functions"
    ]
  ];

  return {
    presets,
    plugins
  };
}


// {
//   "only": ["**/*.js"],
//   "presets": [
//     [
//       "@babel/preset-env",
//       {
//         "targets": {
//           "node": 4
//         }
//       }
//     ],
//     "@babel/preset-flow"
//   ],
//   "plugins": [
//     [
//       "@babel/plugin-transform-flow-strip-types"
//     ],
//     ["@babel/plugin-transform-modules-commonjs", {
//       "lazy": ["*"]
//     }],
//     [
//       "babel-plugin-transform-builtin-extend",
//       {
//         "globals": [
//           "Error",
//           "Array",
//           "Map"
//         ]
//       }
//     ],
//     [
//       "@babel/plugin-transform-runtime",
//       {
//         "helpers": false,
//         "regenerator": true
//       }
//     ],
//     [
//       "syntax-async-functions"
//     ]
//   ]
// }
