"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = npmLogin;

function _fs() {
  var data = _interopRequireDefault(require("fs"));

  _fs = function _fs() {
    return data;
  };

  return data;
}

function _path() {
  var data = _interopRequireDefault(require("path"));

  _path = function _path() {
    return data;
  };

  return data;
}

function _iniBuilder() {
  var data = _interopRequireDefault(require("ini-builder"));

  _iniBuilder = function _iniBuilder() {
    return data;
  };

  return data;
}

function _userHome() {
  var data = _interopRequireDefault(require("user-home"));

  _userHome = function _userHome() {
    return data;
  };

  return data;
}

function _constants() {
  var data = require("../constants");

  _constants = function _constants() {
    return data;
  };

  return data;
}

function _exceptions() {
  var data = require("./exceptions");

  _exceptions = function _exceptions() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findrc(pathToNpmrc) {
  var userNpmrc = _path().default.join(_userHome().default, '.npmrc');

  if (pathToNpmrc) {
    if (!_fs().default.existsSync(pathToNpmrc)) throw new (_exceptions().PathToNpmrcNotExist)(pathToNpmrc);

    var stats = _fs().default.statSync(pathToNpmrc);

    if (stats.isFile()) userNpmrc = pathToNpmrc;else userNpmrc = _path().default.join(pathToNpmrc, '.npmrc');
  }

  return userNpmrc;
}

function mergeOrCreateConfig(token, url) {
  var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var strippedUrl = url.replace(/(^\w+:|^)\/\//, '');

  var iniReg = _iniBuilder().default.find(config, `${_constants().DEFAULT_BINDINGS_PREFIX}:registry`);

  var iniToken = _iniBuilder().default.find(config, `//${strippedUrl}/:_authToken`);

  if (!iniReg) {
    config.push({
      path: [`${_constants().DEFAULT_BINDINGS_PREFIX}:registry`],
      value: url
    });
  } else {
    iniReg.value = url;
  }

  if (!iniToken) {
    config.push({
      path: [`//${strippedUrl}/:_authToken`],
      value: token
    });
  } else {
    iniToken.value = token;
  }

  return config;
}

function npmLogin(token, pathToNpmrc, url) {
  var npmrcPath = findrc(pathToNpmrc);
  var npmrcConfig = _fs().default.existsSync(npmrcPath) ? mergeOrCreateConfig(token, url, _iniBuilder().default.parse(_fs().default.readFileSync(npmrcPath, 'utf-8'))) : mergeOrCreateConfig(token, url);

  try {
    _fs().default.writeFileSync(npmrcPath, _iniBuilder().default.serialize(npmrcConfig));
  } catch (err) {
    throw new (_exceptions().WriteToNpmrcError)(npmrcPath);
  }

  return npmrcPath;
}
//# sourceMappingURL=registry.js.map